//+------------------------------------------------------------------+
//|                                                    QQECandle.mq5 |
//|                               Copyright  2015, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "Copyright  2015, Nikolay Kositsin"
#property link "farria@mail.redcom.ru"
#property description "QQECandle"
//---   
#property version   "1.00"
//+----------------------------------------------+
//|                  |
//+----------------------------------------------+
//---     
#property indicator_separate_window
//---        
#property indicator_buffers 5
//---     
#property indicator_plots   1
//---      
#property indicator_type1   DRAW_COLOR_CANDLES
#property indicator_color1   clrDeepPink,clrGray,clrBlueViolet
//---   
#property indicator_label1  "QQECandle Open;QQECandle High;QQECandle Low;QQECandle Close"
//+----------------------------------------------+
//|                            |
//+----------------------------------------------+
#define RESET  0 //        
//+----------------------------------------------+
//|   CXMA                         |
//+----------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+----------------------------------------------+
//|                        |
//+----------------------------------------------+
enum mode
  {
   MODE_MAIN,  //   
   MODE_SIGN,  //   
   MODE_DIFF   //   
  };
//+----------------------------------------------+
//|                    |
//+----------------------------------------------+
input mode Mode=MODE_DIFF;                //  
input uint RSI_Period=123;
input uint SF=41;
input double DARFACTOR=4.236;
input Smooth_Method XMA_Method=MODE_SMA;  //  
input int XPhase=15; //  
//--- XPhase:  JJMA    -100 ... +100,     ;
//--- XPhase:  VIDIA   CMO,  AMA    
input int Shift=0;                        //      
//+----------------------------------------------+
//---   ,   
//---      
double ExtOpenBuffer[];
double ExtHighBuffer[];
double ExtLowBuffer[];
double ExtCloseBuffer[];
double ExtColorBuffer[];
//---      
int min_rates_total;
//---      
int Ind_Handle[4];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//---    
   int Wilders_Period=int(RSI_Period*2-1);
   min_rates_total=int(RSI_Period+1);
   min_rates_total+=GetStartBars(XMA_Method,SF,XPhase)+1;
   min_rates_total+=GetStartBars(XMA_Method,Wilders_Period,XPhase);
   min_rates_total+=GetStartBars(XMA_Method,Wilders_Period,XPhase);
//---    iQQE
   Ind_Handle[0]=iCustom(NULL,0,"QQECloudX",RSI_Period,SF,DARFACTOR,XMA_Method,XPhase,PRICE_OPEN,0);
   if(Ind_Handle[0]==INVALID_HANDLE)
     {
      Print("      iQQE["+string(0)+"]!");
      return(INIT_FAILED);
     }
//---   
   Ind_Handle[1]=iCustom(NULL,0,"QQECloudX",RSI_Period,SF,DARFACTOR,XMA_Method,XPhase,PRICE_HIGH,0);
   if(Ind_Handle[1]==INVALID_HANDLE)
     {
      Print("      iQQE["+string(1)+"]!");
      return(INIT_FAILED);
     }
//---
   Ind_Handle[2]=iCustom(NULL,0,"QQECloudX",RSI_Period,SF,DARFACTOR,XMA_Method,XPhase,PRICE_LOW,0);
   if(Ind_Handle[2]==INVALID_HANDLE)
     {
      Print("      iQQE["+string(2)+"]!");
      return(INIT_FAILED);
     }
//---
   Ind_Handle[3]=iCustom(NULL,0,"QQECloudX",RSI_Period,SF,DARFACTOR,XMA_Method,XPhase,PRICE_CLOSE,0);
   if(Ind_Handle[3]==INVALID_HANDLE)
     {
      Print("      iQQE["+string(3)+"]!");
      return(INIT_FAILED);
     }
//---      
   SetIndexBuffer(0,ExtOpenBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,ExtHighBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,ExtLowBuffer,INDICATOR_DATA);
   SetIndexBuffer(3,ExtCloseBuffer,INDICATOR_DATA);
//---     ,     
   SetIndexBuffer(4,ExtColorBuffer,INDICATOR_COLOR_INDEX);
//---       
   ArraySetAsSeries(ExtOpenBuffer,true);
   ArraySetAsSeries(ExtHighBuffer,true);
   ArraySetAsSeries(ExtLowBuffer,true);
   ArraySetAsSeries(ExtCloseBuffer,true);
   ArraySetAsSeries(ExtColorBuffer,true);
//---       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//---      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,2);
//---         
   string short_name="QQECandle";
   IndicatorSetString(INDICATOR_SHORTNAME,short_name);
//---  
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---       
   if(BarsCalculated(Ind_Handle[0])<rates_total
      || BarsCalculated(Ind_Handle[1])<rates_total
      || BarsCalculated(Ind_Handle[2])<rates_total
      || BarsCalculated(Ind_Handle[3])<rates_total
      || rates_total<min_rates_total)
      return(RESET);
//---    
   int to_copy,limit,bar;
//---         limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
     {
      limit=rates_total-1; //      
     }
   else
     {
      limit=rates_total-prev_calculated; //      
     }
//---
   to_copy=limit+1;
//---      
   switch(Mode)
     {
      case  MODE_MAIN:
         if(CopyBuffer(Ind_Handle[0],MAIN_LINE,0,to_copy,ExtOpenBuffer)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[1],MAIN_LINE,0,to_copy,ExtHighBuffer)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[2],MAIN_LINE,0,to_copy,ExtLowBuffer)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[3],MAIN_LINE,0,to_copy,ExtCloseBuffer)<=0) return(RESET);
         break;
         //---
      case  MODE_SIGN:
         if(CopyBuffer(Ind_Handle[0],SIGNAL_LINE,0,to_copy,ExtOpenBuffer)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[1],SIGNAL_LINE,0,to_copy,ExtHighBuffer)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[2],SIGNAL_LINE,0,to_copy,ExtLowBuffer)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[3],SIGNAL_LINE,0,to_copy,ExtCloseBuffer)<=0) return(RESET);
         break;
         //---
      case  MODE_DIFF:
        {
         double MOpen[],MHigh[],MLow[],MClose[],SOpen[],SHigh[],SLow[],SClose[];
         //---    ,     
         ArraySetAsSeries(MOpen,true);
         ArraySetAsSeries(MHigh,true);
         ArraySetAsSeries(MLow,true);
         ArraySetAsSeries(MClose,true);
         ArraySetAsSeries(SOpen,true);
         ArraySetAsSeries(SHigh,true);
         ArraySetAsSeries(SLow,true);
         ArraySetAsSeries(SClose,true);
         //--- 
         if(CopyBuffer(Ind_Handle[0],MAIN_LINE,0,to_copy,MOpen)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[1],MAIN_LINE,0,to_copy,MHigh)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[2],MAIN_LINE,0,to_copy,MLow)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[3],MAIN_LINE,0,to_copy,MClose)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[0],SIGNAL_LINE,0,to_copy,SOpen)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[1],SIGNAL_LINE,0,to_copy,SHigh)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[2],SIGNAL_LINE,0,to_copy,SLow)<=0) return(RESET);
         if(CopyBuffer(Ind_Handle[3],SIGNAL_LINE,0,to_copy,SClose)<=0) return(RESET);
         //---
         for(bar=limit; bar>=0 && !IsStopped(); bar--)
           {
            ExtOpenBuffer[bar]=MOpen[bar]-SOpen[bar];
            ExtCloseBuffer[bar]=MClose[bar]-SClose[bar];
            ExtLowBuffer[bar]=MLow[bar]-SLow[bar];
            ExtHighBuffer[bar]=MHigh[bar]-SHigh[bar];
           }
        }
     }
//---      
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      //---   
      double max=MathMax(ExtOpenBuffer[bar],ExtCloseBuffer[bar]);
      if(ExtHighBuffer[bar]<max) ExtHighBuffer[bar]=max;
      double min=MathMin(ExtOpenBuffer[bar],ExtCloseBuffer[bar]);
      if(ExtLowBuffer[bar]>min) ExtLowBuffer[bar]=min;
      //---
      if(ExtOpenBuffer[bar]<ExtCloseBuffer[bar]) ExtColorBuffer[bar]=2.0;
      else if(ExtOpenBuffer[bar]>ExtCloseBuffer[bar]) ExtColorBuffer[bar]=0.0;
      else ExtColorBuffer[bar]=1.0;
     }
//---     
   return(rates_total);
  }
//+------------------------------------------------------------------+
